# Coolkit Open API For Device

Coolkit Open API For Device 模块

## 使用方法

```ts
// 1. 导入 coolkit-open-api 的包
import CkApi from 'coolkit-open-api-device';

// 2. 初始化一些参数
CkApi.init({
    appSecret: 'your-appSecret'
    apikey: 'your-device-apikey',
    deviceid: 'your-device-id',
    countryCode: 'your-country-code',
    isDevice?: false, // 由于 keyboard 特殊性，使用的是 app 端接口，该字段为 true 则代表真正设备使用
    timeout?: 15000, // 配置请求超时时间，单位为毫秒，默认15秒
});


// 3. 在登录成功后，调用其它的接口
await CkApi.getGateWayAndSubDevice(); // 获取网关及其子设备信息
await CkApi.getDeviceUser(); // 获取设备的使用者信息
await CkApi.executeScene('your-scene-id'); // 执行指定场景
await CkApi.getCertainScenes(['your-scene-id']); // 获取特定场景
await CkApi.setDeviceSetting({keyboardNotify:0, overheatNotify:0}); // 修改设备设定，二者都可为空
await CkApi.deleteSubDevice('your-device-id'); // 删除子设备
await CkApi.updateSubDevice({
    deviceid: "sub-device-id",
    name?:"sub-device-name",
    params:{}
}) // 更新子设备

```

使用 debug 模式：

```js
CkApi.init({
    appSecret: 'your-appSecret'
    apikey: 'your-device-apikey',
    deviceid: 'your-device-id',
    countryCode: 'your-country-code',
    debug: true, // true - 开启调试模式
});
```

切换测试环境

```js
CkApi.init({
    appSecret: 'your-appSecret'
    apikey: 'your-device-apikey',
    deviceid: 'your-device-id',
    countryCode: 'your-country-code',
    useTestEnv: true,
});
```

## 上传代码

1. `$ npm login --registry=http://172.16.9.22:4873/`

2. `$ npm publish --registry=http://172.16.9.22:4873/`
