"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const store_1 = require("./store");
const api_1 = __importDefault(require("./api"));
const utils_1 = require("./utils");
function init(params) {
    const { deviceid, appSecret, debug, apikey, region, isDevice = false, useTestEnv = false, timeout = 15000 } = params;
    store_1.setDeviceId(deviceid);
    store_1.setApiKey(apikey);
    store_1.setAppSecret(appSecret);
    store_1.setIsDevice(isDevice);
    store_1.setUseTestEev(useTestEnv);
    utils_1.setDomainByCountryCode(region);
    store_1.setTimeout(timeout);
    if (debug) {
        store_1.setDebug(debug);
    }
    console.log('配置完成');
}
exports.default = Object.assign({ init,
    showStore: store_1.showStore }, api_1.default);
