import { ApiResponse } from '../index';
export interface QuestionnaireData {
    questionId: number;
    title: string;
    content: string[];
}
export declare const other: {
    uploadQuestionnaire(params: {
        type: string;
        from: string;
        duration: number;
        data: QuestionnaireData[];
    }): Promise<ApiResponse>;
    commonStatistics(params: {
        category: string;
        data: {
            from: string;
            type: string;
            deviceid: string;
            value?: number;
        };
    }): Promise<ApiResponse>;
    getThirdPlatformAuthCode(params: {
        platform: string;
        clientId: string;
        data: any;
    }): Promise<{
        error: number;
        msg: string;
        data: {
            code?: string;
            expiredAt?: number;
            extra?: any;
        };
    }>;
    getUploadFileS3PreSignUrl(params: {
        from: string;
        type: string;
        data?: any;
    }): Promise<{
        error: number;
        msg: string;
        data: {
            url: string;
            fields: {
                key: string;
                bucket: string;
                'X-Amz-Algorithm': string;
                'X-Amz-Credential': string;
                'X-Amz-Date': string;
                'X-Amz-Security-Token': string;
                Policy: string;
                'X-Amz-Signature': string;
            };
        };
    }>;
    eventTracking(params: {
        events: any[];
    }): Promise<ApiResponse>;
};
